"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DerivedUser = exports.TestUser = exports.SubClass = void 0;
var entropic_bond_1 = require("entropic-bond");
var SubClass = /** @class */ (function (_super) {
    __extends(SubClass, _super);
    function SubClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(SubClass.prototype, "year", {
        get: function () {
            return this._year;
        },
        set: function (value) {
            this._year = value;
        },
        enumerable: false,
        configurable: true
    });
    __decorate([
        entropic_bond_1.persistent
    ], SubClass.prototype, "_year", void 0);
    SubClass = __decorate([
        entropic_bond_1.registerPersistentClass('SubClass')
    ], SubClass);
    return SubClass;
}(entropic_bond_1.Persistent));
exports.SubClass = SubClass;
var TestUser = /** @class */ (function (_super) {
    __extends(TestUser, _super);
    function TestUser() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._manyRefs = [];
        return _this;
    }
    Object.defineProperty(TestUser.prototype, "name", {
        get: function () {
            return this._name;
        },
        set: function (value) {
            this._name = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestUser.prototype, "age", {
        get: function () {
            return this._age;
        },
        set: function (value) {
            this._age = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestUser.prototype, "admin", {
        get: function () {
            return this._admin;
        },
        set: function (value) {
            this._admin = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestUser.prototype, "skills", {
        get: function () {
            return this._skills;
        },
        set: function (value) {
            this._skills = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestUser.prototype, "documentRef", {
        get: function () {
            return this._documentRef;
        },
        set: function (value) {
            this._documentRef = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestUser.prototype, "manyRefs", {
        get: function () {
            return this._manyRefs;
        },
        set: function (value) {
            this._manyRefs = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestUser.prototype, "derived", {
        get: function () {
            return this._derived;
        },
        set: function (value) {
            this._derived = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TestUser.prototype, "manyDerived", {
        get: function () {
            return this._manyDerived;
        },
        set: function (value) {
            this._manyDerived = value;
        },
        enumerable: false,
        configurable: true
    });
    __decorate([
        entropic_bond_1.persistent
    ], TestUser.prototype, "_name", void 0);
    __decorate([
        entropic_bond_1.persistent
    ], TestUser.prototype, "_age", void 0);
    __decorate([
        entropic_bond_1.persistent
    ], TestUser.prototype, "_admin", void 0);
    __decorate([
        entropic_bond_1.persistent
    ], TestUser.prototype, "_skills", void 0);
    __decorate([
        entropic_bond_1.persistentReference
    ], TestUser.prototype, "_documentRef", void 0);
    __decorate([
        entropic_bond_1.persistentReference
    ], TestUser.prototype, "_manyRefs", void 0);
    __decorate([
        entropic_bond_1.persistentReferenceAt('TestUser')
    ], TestUser.prototype, "_derived", void 0);
    __decorate([
        entropic_bond_1.persistentReferenceAt('TestUser')
    ], TestUser.prototype, "_manyDerived", void 0);
    TestUser = __decorate([
        entropic_bond_1.registerPersistentClass('TestUser')
    ], TestUser);
    return TestUser;
}(entropic_bond_1.Persistent));
exports.TestUser = TestUser;
var DerivedUser = /** @class */ (function (_super) {
    __extends(DerivedUser, _super);
    function DerivedUser() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DerivedUser.prototype, "salary", {
        get: function () {
            return this._salary;
        },
        set: function (value) {
            this._salary = value;
        },
        enumerable: false,
        configurable: true
    });
    __decorate([
        entropic_bond_1.persistent
    ], DerivedUser.prototype, "_salary", void 0);
    DerivedUser = __decorate([
        entropic_bond_1.registerPersistentClass('DerivedUser')
    ], DerivedUser);
    return DerivedUser;
}(TestUser));
exports.DerivedUser = DerivedUser;
//# sourceMappingURL=test-user.js.map